package com.muyu.cargateway.service.Impl;

import com.muyu.cargateway.domain.VehicleConnection;
import com.muyu.cargateway.domain.req.VehicleConnectionReq;
import com.muyu.cargateway.mapper.CarOneClickOperationMapper;
import com.muyu.cargateway.service.CarOneClickOperationService;
import lombok.extern.log4j.Log4j2;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @ Tool：IntelliJ IDEA
 * @ Author：CHX
 * @ Date：2024-09-26-20:16
 * @ Version：1.0
 * @ Description：车辆一键操作业务实现层
 * @author Lenovo
 */
@Log4j2
@Service
public class CarOneClickOperationServiceImpl implements CarOneClickOperationService {

    @Autowired
    private CarOneClickOperationMapper carOneClickOperationMapper;

    @Autowired
    private RabbitTemplate rabbitTemplate;

    /**
     * 获取连接信息
     * @param vehicleConnectionReq 车辆连接请求参数
     * @return
     */
    @Override
    public void getConnect(VehicleConnectionReq vehicleConnectionReq) {
        log.info("车辆连接请求:{}",vehicleConnectionReq.toString());

        // 发送消息
        rabbitTemplate.convertAndSend("exchange_topics_inform","inform.#.email.#",vehicleConnectionReq.getVehicleVin());
        log.info("发送消息成功:{}",vehicleConnectionReq.getVehicleVin());


        VehicleConnection vehicleConnection = new VehicleConnection();
        vehicleConnection.setVehicleVin(vehicleConnectionReq.getVehicleVin());
        vehicleConnection.setUsername(vehicleConnectionReq.getUsername());
        vehicleConnection.setPassword(vehicleConnectionReq.getVehicleVin()+vehicleConnectionReq.getTimestamp()+vehicleConnectionReq.getNonce());
        carOneClickOperationMapper.addConnect(vehicleConnection);
    }
}
